package auth

import (
	"context"
	"net/http"

	"bdrp-server/app/main/api/internal/logic/auth"
	"bdrp-server/app/main/api/internal/svc"
	"bdrp-server/app/main/api/internal/types"
	"bdrp-server/common/result"
	"bdrp-server/pkg/captcha"
	"bdrp-server/pkg/lzkit/validator"

	"github.com/zeromicro/go-zero/rest/httpx"
)

func SendSmsHandler(svcCtx *svc.ServiceContext) http.HandlerFunc {
	return func(w http.ResponseWriter, r *http.Request) {
		var req types.SendSmsReq
		if err := httpx.Parse(r, &req); err != nil {
			result.ParamErrorResult(r, w, err)
			return
		}
		if err := validator.Validate(req); err != nil {
			result.ParamValidateErrorResult(r, w, err)
			return
		}
		// 将 request 注入 context，供 captcha 包判断微信等环境时跳过图形验证
		ctx := context.WithValue(r.Context(), captcha.HTTPRequestContextKey, r)
		l := auth.NewSendSmsLogic(ctx, svcCtx)
		err := l.SendSms(&req)
		result.HttpResult(r, w, nil, err)
	}
}
